> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Invoice and collect

POST https://rest.test.zuora.com/v1/operations/invoice-collect
Content-Type: application/json

Generates and posts invoices and credit memos and collects payments for posted invoices. Credit memos are only available if you have the Invoice Settlement feature enabled and negative charges exist. Credit memos will not be applied to invoices. If draft invoices and credit memos exist when you run this operation, this operation will post the invoices and credit memos. Note that draft credit memos created from an invoice or a product rate plan charge will not be posted.

You can use this operation to generate invoices and collect payments on the posted invoices,
 or else simply collect payment on a specified existing
invoice. The customer's default payment method is used, and the full
amount due is collected. The operation depends on the parameters you
specify.

- To generate one or more new invoices for that customer and collect
payment on the generated and other unpaid invoice(s), leave the **invoiceId** field empty. 

- To collect payment on an existing invoice, specify the invoice ID. 


The operation is atomic; if any part is unsuccessful, the entire
operation is rolled back.

When an error occurs, gateway reason codes and error messages are returned the error response of this operation. The following items are some gateway response code examples.

- Orbital: `05 Do Not Honor`; `14 Invalid Credit Card Number`
- Vantiv: `301 Invalid Account Number`; `304 Lost/Stolen Card`  
- CyberSource2: `202 Expired card`; `231 Invalid account number`

For more reason code information, see the corresponding payment gateway documentation. 


### Notes

Timeouts may occur when using this method on an account that
has an extremely high number of subscriptions.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/billing-documents/operations/post-transaction-invoice-payment

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a POSTInvoiceCollectType.

- `accountKey` (string, required) — Customer account ID or account number.
- `documentDate` (date, optional) — The date that should appear on the invoice and credit memo being generated, in `yyyy-mm-dd` format. If this field is omitted and `invoiceId` is not specified, the current date is used by default. **Note:** The credit memo is only available if you have the Invoice Settlement feature enabled. **Note**: This field is available only if you are on the latest Zuora API version, or you set the `Zuora-Version` request header to `215.0` or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version).
- `invoiceId` (string, optional) — The ID or number of an existing invoice for which to collect payment using the account's default payment method. If this value is specified, no new invoice is generated, and the following fields are ignored: - `invoiceDate` and `invoiceTargetDate` (if the Zuora minor API version is 214.0 or earlier) - `documentDate` and `targetDate` (if the Zuora minor API version is 215.0 or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version))
- `paymentGateway` (string, optional) — The name of the gateway that will be used for the payment. Must be a valid gateway name and the gateway must support the specific payment method. If a value is not specified, the default gateway on the Account will be used.
- `targetDate` (date, optional) — The date through which to calculate charges on this account if an invoice or a credit memo is generated, in `yyyy-mm-dd` format. If this field is omitted and `invoiceId` is not specified, the current date is used by default. This field is available only if you are on the latest Zuora API version, or you set the `Zuora-Version` request header to `215.0` or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version). **Note:** The credit memo is only available if you have the Invoice Settlement feature enabled.

## Response

### 200

OK

- `amountCollected` (double, optional) — Payment amount applied.
- `creditMemos` (list of POSTInvoiceCollectCreditMemosType, optional) — Information on one or more credit memos associated with this operation.
- `invoices` (list of POSTInvoiceCollectInvoicesType, optional) — Information on one or more invoices associated with this operation.
- `paymentId` (string, optional) — Payment ID.
- `success` (boolean, optional) — Returns `true` if the request was processed successfully.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### POSTInvoiceCollectCreditMemosType

- `id` (string, optional) — The ID of the credit memo.
- `totalAmount` (double, optional) — The amount of the credit memo.
- `memoNumber` (string, optional) — The unique identification number of the credit memo.

### POSTInvoiceCollectInvoicesType

- `invoiceAmount` (string, optional) — The amount of the invoice.
- `invoiceId` (string, optional) — The ID of the invoice.
- `invoiceNumber` (string, optional) — The unique identification number of the invoice.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "accountKey": "4028925a4cb74ec9014cb7520fc00005",
  "invoiceId": "4028925a4cb74ec9014cb7540988002e"
}
```

**Response**

```json
{
  "amountCollected": 801.73,
  "creditMemos": [
    {
      "id": "402890555a7e9791015a879f064a0054",
      "totalAmount": 801.73,
      "memoNumber": "CM00000012"
    }
  ],
  "invoices": [
    {
      "invoiceAmount": "801.73",
      "invoiceId": "4028925a4cb74ec9014cb7540988002e",
      "invoiceNumber": "INV00000091"
    }
  ],
  "paymentId": "402892053e100406013e1024ab7c00e3",
  "success": true
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/operations/invoice-collect"

payload = {
    "accountKey": "4028925a4cb74ec9014cb7520fc00005",
    "invoiceId": "4028925a4cb74ec9014cb7540988002e"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/operations/invoice-collect';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"accountKey":"4028925a4cb74ec9014cb7520fc00005","invoiceId":"4028925a4cb74ec9014cb7540988002e"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/operations/invoice-collect"

	payload := strings.NewReader("{\n  \"accountKey\": \"4028925a4cb74ec9014cb7520fc00005\",\n  \"invoiceId\": \"4028925a4cb74ec9014cb7540988002e\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/operations/invoice-collect")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"accountKey\": \"4028925a4cb74ec9014cb7520fc00005\",\n  \"invoiceId\": \"4028925a4cb74ec9014cb7540988002e\"\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/operations/invoice-collect")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"accountKey\": \"4028925a4cb74ec9014cb7520fc00005\",\n  \"invoiceId\": \"4028925a4cb74ec9014cb7540988002e\"\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/operations/invoice-collect', [
  'body' => '{
  "accountKey": "4028925a4cb74ec9014cb7520fc00005",
  "invoiceId": "4028925a4cb74ec9014cb7540988002e"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/operations/invoice-collect");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"accountKey\": \"4028925a4cb74ec9014cb7520fc00005\",\n  \"invoiceId\": \"4028925a4cb74ec9014cb7540988002e\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "accountKey": "4028925a4cb74ec9014cb7520fc00005",
  "invoiceId": "4028925a4cb74ec9014cb7540988002e"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/operations/invoice-collect")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```